/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32wlxx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define RTC_N_PREDIV_S 10
#define RTC_PREDIV_S ((1<<RTC_N_PREDIV_S)-1)
#define RTC_PREDIV_A ((1<<(15-RTC_N_PREDIV_S))-1)
#if	defined(STM32WL55xx)
#define LED1_Pin GPIO_PIN_15
#define LED1_GPIO_Port GPIOB
#endif
#define LED2_Pin GPIO_PIN_9
#define LED2_GPIO_Port GPIOB
#define BUT1_Pin GPIO_PIN_0
#define BUT1_GPIO_Port GPIOA
#define BUT1_EXTI_IRQn EXTI0_IRQn

#define PROB2_Pin GPIO_PIN_13
#define PROB2_GPIO_Port GPIOB
#define PROB1_Pin GPIO_PIN_12
#define PROB1_GPIO_Port GPIOB


#define BUT3_Pin GPIO_PIN_6
#define BUT3_GPIO_Port GPIOC
#define BUT3_EXTI_IRQn EXTI9_5_IRQn
#define BUT2_Pin GPIO_PIN_1
#define BUT2_GPIO_Port GPIOA
#define BUT2_EXTI_IRQn EXTI1_IRQn
#define LED3_Pin GPIO_PIN_11
#define LED3_GPIO_Port GPIOB
#define USARTx_RX_Pin GPIO_PIN_3
#define USARTx_RX_GPIO_Port GPIOA
#define USARTx_TX_Pin GPIO_PIN_2
#define USARTx_TX_GPIO_Port GPIOA

/* USER CODE BEGIN Private defines */
#define BUT1_Pin GPIO_PIN_0
#define BUT1_GPIO_Port GPIOA
#define BUT1_EXTI_IRQn EXTI0_IRQn

#define LED1_Pin 						GPIO_PIN_2
#define LED1_GPIO_Port 					GPIOB

#define LED1_ON			HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_SET )
#define LED1_OFF		HAL_GPIO_WritePin(LED1_GPIO_Port, LED1_Pin, GPIO_PIN_RESET)
#define LED1_STATE		HAL_GPIO_ReadPin(LED1_GPIO_Port, LED1_Pin)
#define LED1_TOGGLE		HAL_GPIO_TogglePin(LED1_GPIO_Port, LED1_Pin)

#ifndef L8
#define MEMS_POWER_Pin							GPIO_PIN_4				// PMU_ENABLE
#define MEMS_POWER_GPIO_Port 					GPIOB					// PMU_ENABLE

#define MEMS_RESET_Pin							GPIO_PIN_4
#define MEMS_RESET_GPIO_Port 					GPIOB

#endif



#define PME_ON			HAL_GPIO_WritePin(MEMS_POWER_GPIO_Port, MEMS_POWER_Pin, GPIO_PIN_SET )
#define PME_OFF			HAL_GPIO_WritePin(MEMS_POWER_GPIO_Port, MEMS_POWER_Pin, GPIO_PIN_RESET )
#define PME_TOGGLE		HAL_GPIO_TogglePin(MEMS_POWER_GPIO_Port, MEMS_POWER_Pin)

#if (defined(TOF_1)||defined(TOF_2)||defined(STS_R1)||defined(STS_R5)||defined(STS_R1D))
#define VL53L0	1U
#elif	(defined(STS_P2)||defined(STS_T6))
#define VL53LX		1U
#endif

/*                 DUAL TOF VL53L0	            */
/*  -------------------- | --------------------	*/
/*  |                    |            		  |	*/
/*  | TOF-2              |	       TOF-1      | */
/*  -------------------- | ------------------ |	*/
/*     U4, PA-9,XSHUT    |    U3, PB-5,XSHUT  |	*/


/*                 SINGLE TOF VL53L0	        */
/*  -----------------------------------------	*/
/*  |                                 		  |	*/
/*  |                     	       TOF-1      | */
/*  ----------------------------------------- |	*/
/*                       |    U3, PB-5        |	*/


#if	defined(VL53LX)||defined(VL53L0)
#ifndef RM2
/*                              TOF-1           */
/*                       |    U3, PB-5 XSHUT  |	*/
/*                        INT PIN PB-3        | */
#define TOF_C_INT_Pin 				GPIO_PIN_3
#define TOF_C_INT_GPIO_Port 		GPIOB
#define TOF_C_INT_EXTI_IRQn 		EXTI3_IRQn

#define TOF_C_XSHUT_Pin 			GPIO_PIN_5
#define TOF_C_XSHUT_GPIO_Port 		GPIOB

#define TOF_INT_EXTI_PIN    		TOF_C_INT_Pin
#define TOF_INT_EXTI_PORT   		TOF_C_INT_GPIO_Port

/*  | TOF-2                                  | */
/*     U4, PA-9  XSHUT                       | */
/*  NT PIN PB-3                              | */
#define TOF_L_INT_Pin 				GPIO_PIN_3
#define TOF_L_INT_GPIO_Port 		GPIOB
#define TOF_L_INT_EXTI_IRQn 		EXTI3_IRQn

#define TOF_L_XSHUT_Pin 			GPIO_PIN_9
#define TOF_L_XSHUT_GPIO_Port 		GPIOA

/*  | TOF-3                                  | */
/*     EXT SOCKET PA-10, XSHUT                      | */
/*  NT PIN PB-3                              | */
#define TOF_R_INT_Pin 				GPIO_PIN_3
#define TOF_R_INT_GPIO_Port 		GPIOB
#define TOF_R_INT_EXTI_IRQn 		EXTI3_IRQn

#define TOF_R_XSHUT_Pin 			GPIO_PIN_10
#define TOF_R_XSHUT_GPIO_Port 		GPIOA

/* ****  PCB BOARD RM2 ****            			*/
/* ****  NO LONG USED ANYMORE FOR TEST ONLY   	*/
#elif	defined(RM2)
/*                              TOF-1           */
/*                       |    U3, PB-3 XSHUT  |	*/
/*                        INT PIN PB-5        | */

#define TOF_C_INT_Pin 				GPIO_PIN_5
#define TOF_C_INT_GPIO_Port 		GPIOB
#define TOF_C_INT_EXTI_IRQn 		EXTI9_5_IRQn

#define TOF_C_XSHUT_Pin 			GPIO_PIN_3
#define TOF_C_XSHUT_GPIO_Port 		GPIOB

#define TOF_INT_EXTI_PIN    		TOF_C_INT_Pin
#define TOF_INT_EXTI_PORT   		TOF_C_INT_GPIO_Port

/*  | TOF-2                                  | */
/*     U4, PA-9  XSHUT                       | */
/*  NT PIN PB-5                              | */
#define TOF_L_INT_Pin 				GPIO_PIN_5
#define TOF_L_INT_GPIO_Port 		GPIOB
#define TOF_L_INT_EXTI_IRQn 		EXTI9_5_IRQn

#define TOF_L_XSHUT_Pin 			GPIO_PIN_9
#define TOF_L_XSHUT_GPIO_Port 		GPIOA

#endif		//RM2

#endif		// defined(VL53LX)||defined(VL53L0)

/* VL53L8A1		for Power_En, LPn, Int */
#ifdef	L8
#define TOF_INT_EXTI_PIN    	(GPIO_PIN_10)		//(GPIO_PIN_4)
#define TOF_INT_EXTI_PORT   	(GPIOA)				//(GPIOA)
#define TOF_INT_EXTI_IRQn		EXTI15_10_IRQn

#define VL53L8A1_PWR_EN_C_PIN   (GPIO_PIN_7)		//(GPIO_PIN_7)
#define VL53L8A1_PWR_EN_C_PORT  (GPIOA)				//(GPIOA)

#define VL53L8A1_LPn_C_PIN   	(GPIO_PIN_4)		//(GPIO_PIN_0)
#define VL53L8A1_LPn_C_PORT  	(GPIOB)				//(GPIOB)

#endif


#define	I2C2_SCL_PIN	GPIO_PIN_12
#define	I2C2_SDA_PIN	GPIO_PIN_11
#define	I2C2_SCL_PORT	GPIOA
#define	I2C2_SDA_PORT	GPIOA

// FOR STM32WLE5CCU6 UFQFPN48  PA12 PA11
#ifdef STM32WLE5xx
#define I2C2_STANDARD_100K			0x00000E14
#define I2C2_FAST_400K				0x00000004
#define I2C2_FAST_PLUS_1M			0x00000000
#else
/*
 * FOR STM32WLE5CCU6 UFQFPN48  PA12 PA11
 */
#define I2C2_STANDARD_100K			0x00000E14
#define I2C2_FAST_400K				0x00000004
#define I2C2_FAST_PLUS_1M			0x00000000

#endif


/*
 * FOR STM32WL55JCIX UFBGA73  PA12 PA11
 */

#ifdef STM32WL55xx

#define I2C2_STANDARD_100K			0x10805D88
#define I2C2_FAST_400K				0x0090194B
#define I2C2_FAST_PLUS_1M			0x00700814
#endif



#if defined(STS_R4)
/* IF_SOAP_IN, MEMS_IF_3, PA10  */
#define SOAP_STATUS_Pin			GPIO_PIN_10
#define SOAP_STATUS_GPIO_Port	GPIOA

#ifdef RM2
#define SOAP_SWITCH_Pin			GPIO_PIN_3		// 2024-04-08 WAS GPIO_PIN_3
#define SOAP_SWITCH_GPIO_Port	GPIOB
#elif  defined(STS_R4)
/* IF_SENSOR_ON_OFF, MEMS_IF_1, PB3   */
#define SOAP_SWITCH_Pin			GPIO_PIN_5		// 2024-04-08 WAS GPIO_PIN_3
#define SOAP_SWITCH_GPIO_Port	GPIOB
#endif

#define SOAP_DATA		HAL_GPIO_ReadPin(SOAP_STATUS_GPIO_Port,SOAP_STATUS_Pin)
#endif

#if defined(STS_M1)
/* Water leakage MEMS_IF_3, PA10  */
#define WATER_LEAKAGE_STATUS_Pin			GPIO_PIN_10
#define WATER_LEAKAGE_STATUS_GPIO_Port		GPIOA

/* Water leakageON_OFF, MEMS_IF_1, PB5   */
#define WATER_LEAKAGE_SWITCH_Pin			GPIO_PIN_5
#define WATER_LEAKAGE_SWITCH_GPIO_Port		GPIOB

#define WATER_LEAKAGE_DATA		HAL_GPIO_ReadPin(WATER_LEAKAGE_STATUS_GPIO_Port,WATER_LEAKAGE_STATUS_Pin)

#endif

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
